(* basic functions on vectors *)
let sub (x,y,z) (x',y',z') = (x -. x', y -. y', z -. z')
let add (x,y,z) (x',y',z') = (x +. x', y +. y', z +. z')
let add_alpha (x,y,z) alpha (x',y',z') = (x +. alpha *. x', y +. alpha *. y', z +. alpha *. z')
let norm (x,y,z) = sqrt (x*.x +. y*.y +. z*.z)
let dist v v' = norm (sub v v')
let mul a (x,y,z) = (a *. x, a *. y, a *. z)
let normalize v =  mul (1.0 /. norm v) v
let dot (x,y,z) (x',y',z') = x *. x' +. y *. y' +. z *. z'
